;.......script written by trancexx (trancexx at yahoo dot com)

#include "AutoItObject.au3"
#include <WinAPI.au3>

Opt("MustDeclareVars", 1)

; Start AutoItObject
_AutoItObject_StartUp()

; Error monitoring
Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("! COM Error !  Number: 0x" & Hex($oError.number, 8) & "   ScriptLine: " & $oError.scriptline & " - " & $oError.windescription & @CRLF)
	Return
EndFunc   ;==>_ErrFunc


; START

; My wav file
Global $sFile = "2.wav"
; Read file
Global $hFile = FileOpen($sFile, 16)
Global $bBinary = FileRead($hFile)
FileClose($hFile)
; Raw header
Global $tWAVEHeaderByte = DllStructCreate("byte[36]")
DllStructSetData($tWAVEHeaderByte, 1, $bBinary)
; Formated header
Global $tWAVEHeader = DllStructCreate("char RIFF[4];" & _
		"dword ChunkSize;" & _
		"char Format[4];" & _
		"char Subchunk1ID[4];" & _
		"dword Subchunk1Size;" & _
		"word AudioFormat;" & _
		"word NumChannels;" & _
		"dword SampleRate;" & _
		"dword ByteRate;" & _
		"word BlockAlign;" & _
		"word BitsPerSample;", _
		DllStructGetPtr($tWAVEHeaderByte))
; Print data
ConsoleWrite("RIFF: " & DllStructGetData($tWAVEHeader, "RIFF") & @CRLF)
ConsoleWrite("ChunkSize: " & DllStructGetData($tWAVEHeader, "ChunkSize") & @CRLF)
ConsoleWrite("Format: " & DllStructGetData($tWAVEHeader, "Format") & @CRLF)
ConsoleWrite("Subchunk1ID: " & DllStructGetData($tWAVEHeader, "Subchunk1ID") & @CRLF)
ConsoleWrite("Subchunk1Size: " & DllStructGetData($tWAVEHeader, "Subchunk1Size") & @CRLF)
ConsoleWrite("AudioFormat: " & DllStructGetData($tWAVEHeader, "AudioFormat") & @CRLF)
ConsoleWrite("NumChannels: " & DllStructGetData($tWAVEHeader, "NumChannels") & @CRLF)
ConsoleWrite("SampleRate: " & DllStructGetData($tWAVEHeader, "SampleRate") & @CRLF)
ConsoleWrite("ByteRate: " & DllStructGetData($tWAVEHeader, "ByteRate") & @CRLF)
ConsoleWrite("BlockAlign: " & DllStructGetData($tWAVEHeader, "BlockAlign") & @CRLF)
ConsoleWrite("BitsPerSample: " & DllStructGetData($tWAVEHeader, "BitsPerSample") & @CRLF)
; Find "data" chunk offset. It's not always right after the "fmt ". To be on the safe side little complication is needed:
Local $tDATAlength, $iDATAlength
Local $iDATAoffset = StringInStr(BinaryToString($bBinary), "data", 1) ; offset to data
If $iDATAoffset Then
	$tDATAlength = DllStructCreate("dword")
	DllStructSetData($tDATAlength, 1, BinaryMid($bBinary, $iDATAoffset + 4, 4)) ; first 4 is length of "data" and other of dword.
	$iDATAlength = DllStructGetData($tDATAlength, 1) ; size of raw data (samples)
EndIf
; Put samples data to raw structure
Global $tSamplesData = DllStructCreate("byte[" & $iDATAlength & "]")
DllStructSetData($tSamplesData, 1, BinaryMid($bBinary, $iDATAoffset + 8, $iDATAlength)) ; 8 is two fours from the above added

; Calculate duration out of header data
Global $iDuration = $iDATAlength / (DllStructGetData($tWAVEHeader, "BitsPerSample") * DllStructGetData($tWAVEHeader, "SampleRate") * DllStructGetData($tWAVEHeader, "NumChannels") / 8)
ConsoleWrite("Duration: " & $iDuration & " sec" & @CRLF)

; WAVEFORMATEX structure (http://msdn.microsoft.com/en-us/library/microsoft.directx_sdk.reference.waveformatex(VS.85).aspx)
Local $tWAVEFORMATEX = DllStructCreate("align 2;word FormatTag;" & _
		"word Channels;" & _
		"dword SamplesPerSec;" & _
		"dword AvgBytesPerSec;" & _
		"word BlockAlign;" & _
		"word BitsPerSample;" & _
		"word Size")
; DSBUFFERDESC structure (http://msdn.microsoft.com/en-us/library/microsoft.directx_sdk.reference.dsbufferdesc(VS.85).aspx)
Local $tDSBUFFERDESC = DllStructCreate("dword Size;" & _
		"dword Flags;" & _
		"dword BufferBytes;" & _
		"dword Reserved;" & _
		"ptr Format")
; Some constants
Local Const $DSBCAPS_CTRLPOSITIONNOTIFY = 256
Local Const $DSBCAPS_CTRLFREQUENCY = 32
Local Const $DSBCAPS_GLOBALFOCUS = 32768
Local Const $DSSCL_NORMAL = 1
Local Const $DSBLOCK_ENTIREBUFFER = 2
Local Const $DSBPLAY_LOOPING = 1

; Go direct. DirectSound8 over DirectSound only because of the convinient links (http://msdn.microsoft.com/en-us/library/microsoft.directx_sdk.reference.directsoundcreate8(VS.85).aspx)
Local $aCall = DllCall("dsound.dll", "long", "DirectSoundCreate8", _
		"ptr", 0, _
		"ptr*", 0, _
		"ptr", 0)
If @error Or $aCall[0] Then
	Exit -1 ; DirectSoundCreate8 or call to it failed
EndIf
; Collect
Local $pDSound = $aCall[2]
; Define IDirectSound8 vTable methods
Local $tagIDirectSound = "QueryInterface;" & _
		"AddRef;" & _
		"Release;" & _ ; IUnknown
		"CreateSoundBuffer;" & _
		"GetCaps;" & _
		"DuplicateSoundBuffer;" & _
		"SetCooperativeLevel;" & _
		"Compact;" & _
		"GetSpeakerConfig;" & _
		"SetSpeakerConfig;" & _
		"Initialize;" & _ ; IDirectSound
		"VerifyCertification;" ; IDirectSound8
; Wrapp IDirectSound8 interface
Local $oIDirectSound8 = _AutoItObject_WrapperCreate($pDSound, $tagIDirectSound)
; Byrocracy... (http://msdn.microsoft.com/en-us/library/microsoft.directx_sdk.idirectsound8.idirectsound8.setcooperativelevel(VS.85).aspx)
Local $aCall = $oIDirectSound8.SetCooperativeLevel("long", "hwnd", Number(_WinAPI_GetDesktopWindow()), "dword", $DSSCL_NORMAL)
If Not IsArray($aCall) Or $aCall[0] Then
	$oIDirectSound8 = 0
	Exit -2 ; SetCooperativeLevel failed
EndIf
; Fill the structures
DllStructSetData($tWAVEFORMATEX, "FormatTag", DllStructGetData($tWAVEHeader, "AudioFormat"))
DllStructSetData($tWAVEFORMATEX, "Channels", DllStructGetData($tWAVEHeader, "NumChannels"))
DllStructSetData($tWAVEFORMATEX, "SamplesPerSec", DllStructGetData($tWAVEHeader, "SampleRate"))
DllStructSetData($tWAVEFORMATEX, "AvgBytesPerSec", DllStructGetData($tWAVEHeader, "ByteRate"))
DllStructSetData($tWAVEFORMATEX, "BlockAlign", DllStructGetData($tWAVEHeader, "BlockAlign"))
DllStructSetData($tWAVEFORMATEX, "BitsPerSample", DllStructGetData($tWAVEHeader, "BitsPerSample"))
DllStructSetData($tWAVEFORMATEX, "Size", 0)
; DSBUFFERDESC structure
DllStructSetData($tDSBUFFERDESC, "Size", DllStructGetSize($tDSBUFFERDESC))
DllStructSetData($tDSBUFFERDESC, "Flags", BitOR($DSBCAPS_CTRLPOSITIONNOTIFY, $DSBCAPS_CTRLFREQUENCY, $DSBCAPS_GLOBALFOCUS))
DllStructSetData($tDSBUFFERDESC, "Format", DllStructGetPtr($tWAVEFORMATEX))
; Buffer size
Local $iBufferSize = $iDATAlength
DllStructSetData($tDSBUFFERDESC, "BufferBytes", $iBufferSize)
; Make SoundBuffer (http://msdn.microsoft.com/en-us/library/microsoft.directx_sdk.idirectsound8.idirectsound8.createsoundbuffer(VS.85).aspx)
$aCall = $oIDirectSound8.CreateSoundBuffer("long", "ptr", Number(DllStructGetPtr($tDSBUFFERDESC)), "ptr*", 0, "ptr", 0)
If Not IsArray($aCall) Or $aCall[0] Then
	$oIDirectSound8 = 0
	Exit -3 ; CreateSoundBuffer failed
EndIf
; Collect data
Local $pDirectSoundBuffer = $aCall[3]
; Define IDirectSoundBuffer vTable methods
Local $tagIDirectSoundBuffer = "QueryInterface;" & _
		"AddRef;" & _
		"Release;" & _ ; IUnknown
		"GetCaps;" & _
		"GetCurrentPosition;" & _
		"GetFormat;" & _
		"GetVolume;" & _
		"GetPan;" & _
		"GetFrequency;" & _
		"GetStatus;" & _
		"Initialize;" & _
		"Lock;" & _
		"Play;" & _
		"SetCurrentPosition;" & _
		"SetFormat;" & _
		"SetVolume;" & _
		"SetPan;" & _
		"SetFrequency;" & _
		"Stop;" & _
		"Unlock;" & _
		"Restore;" ; DirectSoundBuffer
; Wrapp IDirectSoundBuffer interface
Local $oIDirectSoundBuffer = _AutoItObject_WrapperCreate($pDirectSoundBuffer, $tagIDirectSoundBuffer)

; Get original frequency
$aCall = $oIDirectSoundBuffer.GetFrequency("long", "dword*", 0)
If Not IsArray($aCall) Then
	$oIDirectSoundBuffer = 0
	$oIDirectSound8 = 0
	Exit -4 ; GetFrequency failed
EndIf
; Collect data
Local $iPlayFreq = $aCall[2]
; Get pointer to buffer where audio is stored
$aCall = $oIDirectSoundBuffer.Lock("long", "dword", 0, "dword", $iBufferSize, "ptr*", 0, "dword*", 0, "ptr", 0, "ptr", 0, "dword", $DSBLOCK_ENTIREBUFFER)
If Not IsArray($aCall) Or $aCall[0] Then
	$oIDirectSoundBuffer = 0
	$oIDirectSound8 = 0
	Exit -5 ; Lock failed
EndIf
; Collect interesting data out of that call
Local $pWrite = $aCall[4]
Local $iLen = $aCall[5]
; Make writable buffer at thet address
Local $tSoundBuffer = DllStructCreate("byte[" & $iLen & "]", $pWrite)
DllStructSetData($tSoundBuffer, 1, DllStructGetData($tSamplesData, 1))
; Unlock memory (will not check for errors from now on since it's just call, call, call... situation)
$oIDirectSoundBuffer.Unlock("long", "ptr", $pWrite, "dword", $iLen, "ptr", 0, "dword", 0)

; PLAY

; Set some frequency (slow it down)
$oIDirectSoundBuffer.SetFrequency("long", "dword", $iPlayFreq / 1.8)
; Set current position to 0 (start)
$oIDirectSoundBuffer.SetCurrentPosition("long", "dword", 0)
; Play
$oIDirectSoundBuffer.Play("long", "dword", 0, "dword", 0, "dword", $DSBPLAY_LOOPING)
; Sleep
Sleep(1000 * $iDuration * 1.8)
; Stop
$oIDirectSoundBuffer.Stop("long")

; Set new frequency
$oIDirectSoundBuffer.SetFrequency("long", "dword", $iPlayFreq / 1.4)
; Set current position to 0 (start)
$oIDirectSoundBuffer.SetCurrentPosition("long", "dword", 0)
; Play
$oIDirectSoundBuffer.Play("long", "dword", 0, "dword", 0, "dword", $DSBPLAY_LOOPING)
; Sleep
Sleep(1000 * $iDuration * 1.4)
; Stop
$oIDirectSoundBuffer.Stop("long")

; Set original frequency
$oIDirectSoundBuffer.SetFrequency("long", "dword", $iPlayFreq) ; This is the original
; Set current position to 0 (start)
$oIDirectSoundBuffer.SetCurrentPosition("long", "dword", 0)
; Play
$oIDirectSoundBuffer.Play("long", "dword", 0, "dword", 0, "dword", $DSBPLAY_LOOPING)
; Sleep
Sleep(1000 * $iDuration)
; Stop
$oIDirectSoundBuffer.Stop("long")

; Set new frequency (faster)
$oIDirectSoundBuffer.SetFrequency("long", "dword", 1.4 * $iPlayFreq)
; Set current position to 0 (start)
$oIDirectSoundBuffer.SetCurrentPosition("long", "dword", 0)
; Play
$oIDirectSoundBuffer.Play("long", "dword", 0, "dword", 0, "dword", $DSBPLAY_LOOPING)
; Sleep
Sleep(1000 * $iDuration / 1.4)
; Stop
$oIDirectSoundBuffer.Stop("long")


; Set new frequency (faster)
$oIDirectSoundBuffer.SetFrequency("long", "dword", 1.8 * $iPlayFreq)
; Set current position to 0 (start)
$oIDirectSoundBuffer.SetCurrentPosition("long", "dword", 0)
; Play
$oIDirectSoundBuffer.Play("long", "dword", 0, "dword", 0, "dword", $DSBPLAY_LOOPING)
; Sleep
Sleep(1000 * $iDuration / 1.8)
; Stop
$oIDirectSoundBuffer.Stop("long")

; END

;Release objects ($oIDirectSoundBuffer is must!)
$oIDirectSoundBuffer = 0
$oIDirectSound8 = 0